function modeswitch_M1d(handles)
%
%MODESWITCH_M1D
%
%       Switch UI control visibility to the 1D mode and set titles, 
%       then call update_M1d to update the control position/contents.
%

global pvoxM1d PguiData Ptoolbar Phandles;

if ~ nargin
    handles=Phandles;
end

% Determine Previous mode and set/store view appropriately
switch PguiData.mode
    case 'M1d'
        set(handles.menu_1d,'Checked','on');
        set(Ptoolbar.M1d,'State','on');
        return;
    case 'M2d'
        set(handles.menu_2d,'Checked','off');
        set(Ptoolbar.M2d,'State','off');
        %click_reset;
        view(PguiData.az, PguiData.el);
    case 'M3d'
        set(handles.menu_3d,'Checked','off');
        set(Ptoolbar.M3d,'State','off');
    case 'Mdos'
        set(handles.menu_dos,'Checked','off');
        set(Ptoolbar.Mdos,'State','off');
        view(PguiData.az, PguiData.el);
    case 'Mslice'
        set(handles.menu_slice,'Checked','off');
        set(Ptoolbar.Mslice,'State','off');
end

PguiData.mode = 'M1d';
set(handles.menu_1d,'Checked','on');
set(Ptoolbar.M1d,'State','on');

xlabel('');
title('');

%
%change layout data
%
%TODO: change size data
%

set(handles.pulldown_left,'Visible','on');
set(handles.pulldown_right,'Visible','on');

set(handles.slider_h_top,'Visible','off');
set(handles.slider_h_middle,'Visible','off');
set(handles.slider_h_bottom,'Visible','off');
set(handles.text_h_top,'Visible','off');
set(handles.text_h_middle,'Visible','off');
set(handles.text_h_bottom,'Visible','off');

set(handles.text_left,'Visible','on');
set(handles.edit_left,'Visible','on');
set(handles.text_right,'Visible','on');
set(handles.edit_right,'Visible','on');

set(handles.text_left,'String','Point 1');
set(handles.text_right,'String','Point 2');

%energy level & energy of level
if strncmp(PguiData.graph,'wfn',3)

    set(handles.slider_v,'Visible','on');
    set(handles.text_top,'Visible','on');
    set(handles.edit_top,'Visible','on');

    set(handles.text_top,'String','Level');

else

    set(handles.slider_v,'Visible','off');
    set(handles.text_top,'Visible','off');
    set(handles.edit_top,'Visible','off');

end

set(handles.edit_left,'BackgroundColor',[1 1 1]);
set(handles.edit_right,'BackgroundColor',[1 1 1]);
set(handles.edit_top,'BackgroundColor',[1 1 1]);

%top_down toggles
set(handles.togglebutton_top,'Visible','on');
set(handles.togglebutton_middle,'Visible','on');
set(handles.togglebutton_bottom,'Visible','off');

set(handles.togglebutton_top,'String','atoms');
set(handles.togglebutton_middle,'String','plot');

set(handles.togglebutton_middle,'BackgroundColor',[.702 .702 .702]);
set(handles.togglebutton_middle,'Style','togglebutton');
set(handles.togglebutton_top,'Style','togglebutton');

set(handles.togglebutton_middle,'FontWeight','bold');

set(handles.togglebutton_top,'Value', get(handles.togglebutton_top,'Max') );
set(handles.togglebutton_middle,'Value', get(handles.togglebutton_top,'Min') );

%menu stuff
set(handles.menu_pot,'Enable','on');
set(handles.menu_rho,'Enable','on');
set(handles.menu_wfn,'Enable','on');
set(handles.menu_atoms,'Enable','off');

set(Ptoolbar.pot,'Enable','on');
set(Ptoolbar.rho,'Enable','on');
set(Ptoolbar.wfn,'Enable','on');
set(Ptoolbar.atoms,'Enable','off');
set(Ptoolbar.rotate,'Enable','on');
set(Ptoolbar.colorbar,'Enable','off');
set(Ptoolbar.zoomin,'Enable','on');
set(Ptoolbar.reset,'Enable','on');

%
%REGRAPH
%
%UPDATE SLIDERS, TEXTS, AND EDITS
%

if ~(pvoxM1d.init)
    M1d_init;
end

pvoxM1d.atomview=1;

update_M1d('everything');
