function graph_M2d(handle)
%
%GRAPH_M2D
%
%       Graph the data in the 2D mode.
%

global WFNData PguiData pvoxM2d;

axes(handle);

% Get the current location of z coordinate
z_wfn = pvoxM2d.z;

if ( PguiData.draw_mode == 1 )
    set(handle, 'DrawMode', 'normal');
else
    set(handle, 'DrawMode', 'fast');
end

%graph data
if strncmp(PguiData.graph,'wfn',3)
    %pvoxM2d.wfn_scale = [-WFNData.radius WFNData.radius -WFNData.radius WFNData.radius min(min(min(WFNData.wfn(:,:,:,pvoxM2d.level)))) max(max(max(WFNData.wfn(:,:,:,pvoxM2d.level)))) min(min(min(WFNData.wfn(:,:,:,pvoxM2d.level)))) max(max(max(WFNData.wfn(:,:,:,pvoxM2d.level))))];
    s = surf(WFNData.X(1,:,1),WFNData.Y(:,1,1),WFNData.wfn(:,:,pvoxM2d.z,pvoxM2d.level),'FaceColor', 'interp');
elseif strncmp(PguiData.graph,'pot',3)
    s = surf(WFNData.X(1,:,1),WFNData.Y(:,1,1),WFNData.pot(:,:,pvoxM2d.z),'FaceColor', 'interp');
elseif strncmp(PguiData.graph,'rho',3)
    s = surf(WFNData.X(1,:,1),WFNData.Y(:,1,1),WFNData.rho(:,:,pvoxM2d.z),'FaceColor', 'interp');
end

%update graph to take preferences into account

if ( PguiData.gridlines == 0 )
    set (s,'EdgeColor', 'none');
end

colormap(PguiData.colormap);
if ( PguiData.colormap_invert )
    cm = colormap;
    s = size(cm(:,1));
    s = s(1);

    cm2( (s:-1:1),: ) = cm( (1:s),: );

    colormap(cm2);
end

if ( PguiData.draw_mode == 1 )
    set(handle, 'DrawMode', 'normal');
else
    set(handle, 'DrawMode', 'fast');
end
