function modeswitch_M2d(handles)
%
%MODESWITCH_M2D
%
%       Switch UI control visibility to the 2D mode and set titles, 
%       then call update_M2d to update the control position/contents.
%

global pvoxM2d PguiData Ptoolbar Phandles pvoxM1d;

if ~ nargin
    handles=Phandles;
end

% Determine Previous mode and set menus/view appropriately
switch PguiData.mode
    case 'M1d'
        set(handles.menu_1d,'Checked','off');
        set(Ptoolbar.M1d,'State','off');
        if (pvoxM1d.atomview)
            [PguiData.az, PguiData.el] = view;
        end
    case 'M2d'
        set(handles.menu_2d,'Checked','on');
        set(Ptoolbar.M2d,'State','on');
        return;
    case 'M3d'
        set(handles.menu_3d,'Checked','off');
        set(Ptoolbar.M3d,'State','off');
        [PguiData.az, PguiData.el] = view;
    case 'Mdos'
        set(handles.menu_dos,'Checked','off');
        set(Ptoolbar.Mdos,'State','off');
        view(PguiData.az, PguiData.el);
    case 'Mslice'
        set(handles.menu_slice,'Checked','off');
        set(Ptoolbar.Mslice,'State','off');
        [PguiData.az, PguiData.el] = view;
end

PguiData.mode = 'M2d';
set(handles.menu_2d,'Checked','on');
set(Ptoolbar.M2d,'State','on');

xlabel('');
title('');

%
%change layout data
%
%TODO: change size data
%

set(handles.pulldown_left,'Visible','off');
set(handles.pulldown_right,'Visible','off');

set(handles.slider_h_middle,'Visible','off');
set(handles.slider_h_bottom,'Visible','off');
set(handles.text_h_middle,'Visible','off');
set(handles.text_h_bottom,'Visible','off');

%energy level & energy of level
if strncmp(PguiData.graph,'wfn',3)

    set(handles.slider_h_top,'Visible','on');
    set(handles.text_top,'Visible','on');
    set(handles.edit_top,'Visible','on');

    set(handles.text_left,'Visible','on');
    set(handles.edit_left,'Visible','on');
    set(handles.text_right,'Visible','on');
    set(handles.edit_right,'Visible','on');

    set(handles.text_h_top,'String','Level');
    set(handles.text_left,'String','Energy (eV)');
    set(handles.text_right,'String','Level');


else

    set(handles.slider_h_top,'Visible','off');
    set(handles.text_h_top,'Visible','off');
    set(handles.text_left,'Visible','off');
    set(handles.edit_left,'Visible','off');
    set(handles.text_right,'Visible','off');
    set(handles.edit_right,'Visible','off');

end

set(handles.edit_left,'BackgroundColor',[.824 .824 .824]);
set(handles.edit_right,'BackgroundColor',[1 1 1]);
set(handles.edit_top,'BackgroundColor',[1 1 1]);

%top_down toggles
set(handles.togglebutton_top,'Visible','on');
set(handles.togglebutton_middle,'Visible','on');
set(handles.togglebutton_bottom,'Visible','off');

set(handles.togglebutton_top,'String','top down');
set(handles.togglebutton_middle,'String','surface');

set(handles.togglebutton_middle,'BackgroundColor',[.702 .702 .702]);
set(handles.togglebutton_middle,'Style','togglebutton');
set(handles.togglebutton_top,'Style','togglebutton');

set(handles.togglebutton_middle,'FontWeight','bold');

%z stuff
set(handles.slider_v,'Visible','on');
set(handles.text_top,'Visible','on');
set(handles.edit_top,'Visible','on');

set(handles.text_top,'String','Z value');

%menu stuff
set(handles.menu_pot,'Enable','on');
set(handles.menu_rho,'Enable','on');
set(handles.menu_wfn,'Enable','on');
set(handles.menu_atoms,'Enable','off');

set(Ptoolbar.pot,'Enable','on');
set(Ptoolbar.rho,'Enable','on');
set(Ptoolbar.wfn,'Enable','on');
set(Ptoolbar.atoms,'Enable','off');
set(Ptoolbar.rotate,'Enable','on');
set(Ptoolbar.colorbar,'Enable','on');
set(Ptoolbar.zoomin,'Enable','on');
set(Ptoolbar.reset,'Enable','on');

%
%REGRAPH
%
%UPDATE SLIDERS, TEXTS, AND EDITS
%

if ~(pvoxM2d.init)
    M2d_init;
end

update_M2d('everything');

click_reset;
