function modeswitch_Mslice(handles)
%
%MODESWITCH_MSLICE
%
%       Switch UI control visibility to the Slice mode and set titles, 
%       then call update_Mslice to update the control position/contents.
%

global pvoxMslice PguiData Ptoolbar Phandles pvoxM1d pvoxM2d;

if ~ nargin
    handles=Phandles;
end

% Determine Previous mode and set menus/view appropriately
switch PguiData.mode
    case 'M1d'
        set(handles.menu_1d,'Checked','off');
        set(Ptoolbar.M1d,'State','off');
        if (~pvoxM1d.atomview)
            view(PguiData.az, PguiData.el);
        end
    case 'M2d'
        set(handles.menu_2d,'Checked','off');
        set(Ptoolbar.M2d,'State','off');
        %click_reset;
        view(PguiData.az, PguiData.el);
    case 'M3d'
        set(handles.menu_3d,'Checked','off');
        set(Ptoolbar.M3d,'State','off');
    case 'Mdos'
        set(handles.menu_dos,'Checked','off');
        set(Ptoolbar.Mdos,'State','off');
        view(PguiData.az, PguiData.el);
    case 'Mslice'
        set(handles.menu_slice,'Checked','on');
        set(Ptoolbar.Mslice,'State','on');
        return;
end

PguiData.mode = 'Mslice';
set(handles.menu_slice,'Checked','on');
set(Ptoolbar.Mslice,'State','on');

xlabel('');
title('');

%
%change layout data
%
%TODO: change size data
%

set(handles.pulldown_left,'Visible','off');
set(handles.pulldown_right,'Visible','off');

%x,y,z sliders
set(handles.slider_h_top,'Visible','on');
set(handles.slider_h_middle,'Visible','on');
set(handles.slider_h_bottom,'Visible','on');
set(handles.text_h_top,'Visible','on');
set(handles.text_h_middle,'Visible','on');
set(handles.text_h_bottom,'Visible','on');

set(handles.text_h_top,'String','X');
set(handles.text_h_middle,'String','Y');
set(handles.text_h_bottom,'String','Z');

set(handles.text_left,'Visible','off');
set(handles.edit_left,'Visible','off');
set(handles.text_right,'Visible','off');
set(handles.edit_right,'Visible','off');

%energy level and energy of level
if strncmp(PguiData.graph,'wfn',3)
    set(handles.slider_v,'Visible','on');
    set(handles.text_top,'Visible','on');
    set(handles.edit_top,'Visible','on');

    set(handles.text_top,'String','Level');

    set(handles.togglebutton_top,'Visible','on');
    set(handles.togglebutton_middle,'Visible','on');
    set(handles.togglebutton_bottom,'Visible','off');

    set(handles.togglebutton_top,'String','Energy (eV)');

else
    set(handles.slider_v,'Visible','off');
    set(handles.text_top,'Visible','off');
    set(handles.edit_top,'Visible','off');

    set(handles.togglebutton_top,'Visible','off');
    set(handles.togglebutton_middle,'Visible','off');
    set(handles.togglebutton_bottom,'Visible','off');

end

set(handles.togglebutton_middle,'BackgroundColor',[.824 .824 .824]);
set(handles.edit_top,'BackgroundColor',[1 1 1]);
set(handles.togglebutton_middle,'Style','edit');
set(handles.togglebutton_top,'Style','text');
set(handles.togglebutton_bottom,'Visible','off');

set(handles.togglebutton_middle,'FontWeight','normal');

%menu stuff
set(handles.menu_pot,'Enable','on');
set(handles.menu_rho,'Enable','on');
set(handles.menu_wfn,'Enable','on');
set(handles.menu_atoms,'Enable','on');

set(Ptoolbar.pot,'Enable','on');
set(Ptoolbar.rho,'Enable','on');
set(Ptoolbar.wfn,'Enable','on');
set(Ptoolbar.atoms,'Enable','on');
set(Ptoolbar.rotate,'Enable','on');
set(Ptoolbar.colorbar,'Enable','on');
set(Ptoolbar.zoomin,'Enable','on');
set(Ptoolbar.reset,'Enable','on');

if PguiData.atoms
    set(handles.menu_atoms,'Checked','on');
    set(Ptoolbar.atoms,'State','on');
else
    set(handles.menu_atoms,'Checked','off');
    set(Ptoolbar.atoms,'State','off');
end

%
%REGRAPH
%
%UPDATE SLIDERS, TEXTS, AND EDITS
%

if ~(pvoxMslice.init)
    Mslice_init;
end

update_Mslice('everything');
