function varargout = open_recent(varargin)
% OPEN_RECENT M-file for open_recent.fig
%      OPEN_RECENT, by itself, creates a new OPEN_RECENT or raises the existing
%      singleton*.
%
%      H = OPEN_RECENT returns the handle to a new OPEN_RECENT or the handle to
%      the existing singleton*.
%
%      OPEN_RECENT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in OPEN_RECENT.M with the given input arguments.
%
%      OPEN_RECENT('Property','Value',...) creates a new OPEN_RECENT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before open_recent_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to open_recent_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help open_recent

% Last Modified by GUIDE v2.5 10-Aug-2005 13:29:08

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @open_recent_OpeningFcn, ...
                   'gui_OutputFcn',  @open_recent_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before open_recent is made visible.
function open_recent_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to open_recent (see VARARGIN)

% Choose default command line output for open_recent
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes open_recent wait for user response (see UIRESUME)
% uiwait(handles.figure1);

global pvoxView;
pvoxView.recent = handles;


% --- Outputs from this function are returned to the command line.
function varargout = open_recent_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


function file_list_Callback(hObject, eventdata, handles)


function file_list_CreateFcn(hObject, eventdata, handles)

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

global PguiData
set(hObject, 'String', PguiData.recent_list, 'Value', 1);


function push_open_Callback(hObject, eventdata, handles)

global PguiData Phandles Ptoolbar ParsecData WFNData;

set(handles.file_list,'Enable','off');
set(hObject,'Enable','inactive');
set(hObject,'String','Please Wait...');
drawnow;
out_file = PguiData.recent_out{get(handles.file_list,'Value')};
dat_file = PguiData.recent_dat{get(handles.file_list,'Value')};

reg = '/*';
index = max(regexp(out_file,reg));
outfilename = out_file(index+1:size(out_file,2));
rsdft_flag = 0;

rsdft_string = outfilename(1:5);
if(rsdft_string == 'rsdft')
  rsdft_flag = 1;
end

if(rsdft_flag == 0)
  [newParsecData, newWFNData, D_valid, W_valid] = readOutput([out_file], [dat_file]);
  if (~D_valid || ~min(W_valid))
    [newParsecData, newWFNData, D_valid, W_valid] = readOutput_rsdft([out_file], [dat_file]);
  end
  
else
  [newParsecData, newWFNData, D_valid, W_valid] = readOutput_rsdft([out_file], [dat_file]);
  if (~D_valid || ~min(W_valid))
    [newParsecData, newWFNData, D_valid, W_valid] = readOutput([out_file], [dat_file]);
  end
end

%if pvox is closed exit gracefully
global pvoxView;
if pvoxView.closed
    return;
end

% If valid input, Initialize pvox
if (D_valid && min(W_valid) )

    % Write new list back to file
    recent = fopen('pTemp/recent.dat','w');
    fprintf(recent,[out_file '\n']);
    fprintf(recent,[dat_file '\n']);
    length = size(PguiData.recent_out,2);
    if (length > 10)
        length = 10;
    end
    for i = 1:length
        if (i ~= get(handles.file_list,'Value'))
            fprintf(recent,[PguiData.recent_out{i} '\n']);
            fprintf(recent,[PguiData.recent_dat{i} '\n']);
        end
    end
    fclose(recent);
    
    global PguiData Phandles Ptoolbar ParsecData WFNData;

    % If a data set is open
    if PguiData.open_dataset
        % Clear open data set
        clear global ParsecData WFNData
        global ParsecData WFNData pvoxM1d pvoxM2d pvoxM3d pvoxMslice pvoxMdos pvoxView

        try
            atom = pvoxView.atom;
            close(atom.figure1);
            %drawnow;
            %ParsecAtomView;
        end
        try
            iter = pvoxView.iter;
            close(iter.figure1);
            %drawnow;
            %ParsecIterationView;
        end


        % Reset view specific variables
        pvoxM1d.init=0;
        pvoxM2d.init=0;
        pvoxM3d.init=0;
        pvoxMdos.init=0;
        pvoxMslice.init=0;

        ParsecData = newParsecData;
        WFNData = newWFNData;

        % Redraw current view
        switch PguiData.mode
            case 'M1d'
                M1d_init;
                update_M1d('everything');
            case 'M2d'
                M2d_init;
                update_M2d('everything');
            case 'M3d'
                M3d_init;
                update_M3d('everything');
            case 'Mdos'
                Mdos_init;
                update_Mdos('everything');
            case 'Mslice'
                Mslice_init;
                update_Mslice('everything');
        end
        click_reset;

    else
        ParsecData = newParsecData;
        WFNData = newWFNData;

        PguiData.open_dataset=1;

        % Enable menus and toolbar
        set(Phandles.menu_1d,'Enable','on');
        set(Phandles.menu_2d,'Enable','on');
        set(Phandles.menu_3d,'Enable','on');
        set(Phandles.menu_dos,'Enable','on');
        set(Phandles.menu_preferences,'Enable','on');
        set(Phandles.menu_slice,'Enable','on');
        set(Phandles.menu_print,'Enable','on');
        set(Phandles.menu_capture,'Enable','on');

        set(Phandles.axes1,'Visible','on');
        set(Ptoolbar.print,'Enable','on');
        set(Ptoolbar.capture,'Enable','on');

        set(Ptoolbar.zoomin,'Enable','on');
        set(Ptoolbar.reset,'Enable','on');

        set(Ptoolbar.rotate,'Enable','on');
        set(Ptoolbar.colorbar,'Enable','on');

        set(Ptoolbar.AtomView,'Enable','on');
        set(Ptoolbar.IterationView,'Enable','on');

        set(Ptoolbar.M1d,'Enable','on');
        set(Ptoolbar.M2d,'Enable','on');
        set(Ptoolbar.M3d,'Enable','on');
        set(Ptoolbar.Mdos,'Enable','on');
        set(Ptoolbar.Mslice,'Enable','on');

        % Load 2D view of potential - default
        PguiData.graph='pot';
        modeswitch_M2d(Phandles);
    end

    % Determine Window Title
    n=size(ParsecData.typeNum);
    string='pvox _';
    for m=(1: (n(2)) )
        string = strcat( string, mat2str(ParsecData.typeNum(m)), ParsecData.typeName(m,:), '_' );
    end
    set(Phandles.figure1,'Name',string);

    %TODO change current working directory
    %PguiData.workingDir = out_file; learn to remove file

else % Error reading input
    if (~D_valid)
        uiwait(errordlg('Error opening parsec.out','ERROR'));
    end
    if (~W_valid(1))
        uiwait(errordlg('Error in wnf.dat: Cannont read format','ERROR'));
    elseif (~W_valid(2))
        uiwait(errordlg('Error in wnf.dat: Unkown Symmetry Found','ERROR'));
    elseif (~W_valid(3))
        uiwait(errordlg('Error in wnf.dat: error reading potential and charge density','ERROR'));
    elseif (~W_valid(4))
        uiwait(errordlg('Error in wnf.dat: error reading wavefunctions','ERROR'));
    elseif (~W_valid(5))
        uiwait(errordlg('Error in wnf.dat: error creating mesh grid','ERROR'));
    end
end
close(handles.figure1);

