function click_reset(varargin)
%
%CLICK_RESET
%
%       Reset figure callback
%

global Ptoolbar Phandles PguiData pvoxM2d pvoxM1d pvoxMdos;

% Reset tollbar and cursor properties
zoom(Phandles.figure1, 'off');
set(Ptoolbar.reset,'State','off');
set(Ptoolbar.zoomin,'State','off');

% Zoom to standard view
set(Phandles.axes1,'CameraViewAngleMode', 'auto');

% If 2D surface
if ( strcmp(PguiData.mode,'M2d') && ~(pvoxM2d.top_down))
    % Determine mode and set scale/center camera
    switch (PguiData.graph)
        case 'wfn'
            axis(pvoxM2d.wfn_scale);
            camtarget([0,0, (pvoxM2d.wfn_scale(5)+pvoxM2d.wfn_scale(6))/2 ]);
        case 'pot'
            axis(pvoxM2d.pot_scale);
            camtarget([0,0, (pvoxM2d.pot_scale(5)+pvoxM2d.pot_scale(6))/2 ]);
        case 'rho'
            axis(pvoxM2d.rho_scale);
            camtarget([0,0, (pvoxM2d.rho_scale(5)+pvoxM2d.rho_scale(6))/2 ]);
    end
    axis square;
    
% If 2D top-down
elseif (strcmp(PguiData.mode,'M2d') && pvoxM2d.top_down)
    % Determine mode and set scale
    switch (PguiData.graph)
        case 'wfn'
            axis(pvoxM2d.wfn_scale);
        case 'pot'
            axis(pvoxM2d.pot_scale);
        case 'rho'
            axis(pvoxM2d.rho_scale);
    end

% If 1D plot
elseif (strcmp(PguiData.mode,'M1d') && ~(pvoxM1d.atomview))
    % Expand graph to fit screen
    set(Phandles.axes1,'DataAspectRatioMode', 'auto');
    set(Phandles.axes1,'PlotBoxAspectRatioMode', 'auto');
    % Determine mode and set scale
    switch (PguiData.graph)
        case 'wfn'
            axis(pvoxM1d.wfn_scale);
        case 'pot'
            axis(pvoxM1d.pot_scale)
        case 'rho'
            axis(pvoxM1d.rho_scale)
    end

% If DOS
elseif(strcmp(PguiData.mode,'Mdos'))
    %Expand graph to fit screen
    set(Phandles.axes1,'DataAspectRatioMode', 'auto');
    set(Phandles.axes1,'PlotBoxAspectRatioMode', 'auto');
    axis(pvoxMdos.scale)
% 1D atomview, 3D, Slice
else
    % Set axis square and center camera
    axis square;
    camtarget([0,0,0]);
end

drawnow;

update_state;
