function graphswitch_rho(handles)
%
%GRAPHSWITCH_RHO
%
%       Switch the GUI so that the controls for the charge density graph 
%       are available. Then call the update_<mode> function to update 
%       controls and axes.
%
%


global PguiData Phandles Ptoolbar;

%if strncmp( PguiData.graph,'rho',3 )
%    return;
%end

if ~ nargin
    handles=Phandles;
end

PguiData.graph = 'rho';
set(handles.menu_pot,'Checked','off');
set(handles.menu_rho,'Checked','on');
set(handles.menu_wfn,'Checked','off');

set(Ptoolbar.wfn,'State','off');
set(Ptoolbar.pot,'State','off');
set(Ptoolbar.rho,'State','on');

switch PguiData.mode
    case 'M1d'

        %energy level and energy of level
        set(handles.slider_v,'Visible','off');
        set(handles.text_top,'Visible','off');
        set(handles.edit_top,'Visible','off');

        %update texts et al
        update_M1d('rho');

    case 'M2d'

        %energy level and energy of level
        set(handles.slider_h_top,'Visible','off');
        set(handles.text_h_top,'Visible','off');
        set(handles.text_left,'Visible','off');
        set(handles.edit_left,'Visible','off');
        set(handles.text_right,'Visible','off');
        set(handles.edit_right,'Visible','off');

        %update texts et al
        update_M2d('rho');

    case 'M3d'

        %energy level and energy of level
        set(handles.slider_h_top,'Visible','off');
        set(handles.text_h_top,'Visible','off');
        set(handles.text_left,'Visible','off');
        set(handles.edit_left,'Visible','off');
        set(handles.text_right,'Visible','off');
        set(handles.edit_right,'Visible','off');

        %update texts et al
        update_M3d('rho');

    case 'Mslice'

        %energy level and energy of level
        set(handles.slider_v,'Visible','off');
        set(handles.text_top,'Visible','off');
        set(handles.edit_top,'Visible','off');
        set(handles.togglebutton_top,'Visible','off');
        set(handles.togglebutton_middle,'Visible','off');
        set(handles.togglebutton_bottom,'Visible','off');

        %update texts et al
        update_Mslice('rho');

end
